"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileTree = void 0;
var react_1 = __importStar(require("react"));
var react_virtualized_1 = require("react-virtualized");
var TreeItem_1 = require("./TreeItem");
var utils_1 = require("./utils");
function defaultEmptyRenderer() {
    return react_1.default.createElement("div", { className: "file-tree__empty" }, "\u65E0\u5185\u5BB9");
}
function useItemExpandCallback(_a) {
    var _this = this;
    var tree = _a[0], setTree = _a[1], onReadDir = _a[2];
    return (0, react_1.useCallback)(function (treeNode, strategy) {
        if (strategy === void 0) { strategy = "toggle"; }
        if (!tree) {
            return;
        }
        var map = {
            expanded: true,
            collapsed: false,
            toggle: !treeNode.expanded,
        };
        var expanded = map[strategy];
        var loadAsyncChildren = function () { return __awaiter(_this, void 0, void 0, function () {
            var children, newTree_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        setTree(function () {
                            return (0, utils_1.mergeTreeNodeProps)(tree, treeNode.uri, {
                                async: "loading",
                            });
                        });
                        return [4 /*yield*/, (onReadDir === null || onReadDir === void 0 ? void 0 : onReadDir(treeNode.uri))];
                    case 1:
                        children = _a.sent();
                        if (children) {
                            newTree_1 = (0, utils_1.mergeTreeNodeProps)(tree, treeNode.uri, {
                                async: "loaded",
                                expanded: true,
                                children: children,
                            });
                            setTree(function () { return newTree_1; });
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        if (treeNode.type === "directory") {
            treeNode.async === "unloaded"
                ? loadAsyncChildren()
                : setTree((0, utils_1.mergeTreeNodeProps)(tree, treeNode.uri, {
                    expanded: expanded,
                }));
        }
    }, [tree, onReadDir]);
}
var FileTree = function (props) {
    var _a = (0, react_1.useState)(), tree = _a[0], setTree = _a[1];
    (0, react_1.useEffect)(function () {
        setTree(props.root);
    }, [props.root]);
    var items = (0, utils_1.flatTreeData)(tree ? [tree] : []);
    var handleTreeChange = (0, react_1.useCallback)(function (newTree) {
        if (props.onChange) {
            var finalTree = typeof newTree === "function" ? newTree(tree) : newTree;
            props.onChange(finalTree);
        }
        else {
            setTree(newTree);
        }
    }, [setTree, props.onChange]);
    var handleItemExpand = useItemExpandCallback([
        tree,
        handleTreeChange,
        props.onReadDir,
    ]);
    var handlers = {
        create: function (uri, node) { return __awaiter(void 0, void 0, void 0, function () {
            var parentNode;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!tree) {
                            return [2 /*return*/];
                        }
                        parentNode = (0, utils_1.getNodeByUri)(tree, uri);
                        if (!parentNode)
                            return [2 /*return*/];
                        return [4 /*yield*/, ((_a = props === null || props === void 0 ? void 0 : props.onNew) === null || _a === void 0 ? void 0 : _a.call(props, parentNode, node))];
                    case 1:
                        _b.sent();
                        handleTreeChange(function (curTree) { return curTree && (0, utils_1.addChildTo)(curTree, uri, node); });
                        return [2 /*return*/];
                }
            });
        }); },
        renameNode: function (uri) {
            handleTreeChange(function (curTree) {
                return curTree && (0, utils_1.mergeTreeNodeProps)(curTree, uri, { renaming: true });
            });
        },
        renameTo: function (uri, toUri) { return __awaiter(void 0, void 0, void 0, function () {
            var node, renamedNode;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!tree) {
                            return [2 /*return*/];
                        }
                        node = (0, utils_1.getNodeByUri)(tree, uri);
                        if (!node) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, ((_a = props.onRename) === null || _a === void 0 ? void 0 : _a.call(props, node, toUri))];
                    case 1:
                        _b.sent();
                        renamedNode = (0, utils_1.treeMap)(node, function (item) {
                            var newUri = item.uri.replace(uri, toUri);
                            return __assign(__assign({}, item), { renaming: false, uri: newUri });
                        });
                        handleTreeChange(function (t) { return (0, utils_1.mergeTreeNodeProps)(tree, uri, renamedNode); });
                        return [2 /*return*/];
                }
            });
        }); },
        delete: function (uri) { return __awaiter(void 0, void 0, void 0, function () {
            var node;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!tree) {
                            return [2 /*return*/];
                        }
                        node = (0, utils_1.getNodeByUri)(tree, uri);
                        if (!node) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, ((_a = props.onDelete) === null || _a === void 0 ? void 0 : _a.call(props, node))];
                    case 1:
                        _b.sent();
                        handleTreeChange(function (t) { return t && (0, utils_1.removeNode)(t, uri); });
                        return [2 /*return*/];
                }
            });
        }); },
        expand: function (uri, expanded) {
            handleTreeChange(function (t) { return t && (0, utils_1.mergeTreeNodeProps)(t, uri, { expanded: expanded }); });
        },
        cancelRename: function (uri) {
            return handleTreeChange(function (t) { return t && (0, utils_1.mergeTreeNodeProps)(t, uri, { renaming: false }); });
        },
        move: function (fromUri, toUri) { return __awaiter(void 0, void 0, void 0, function () {
            var fromNode, toNode, finalTree_1, name_1, renamedUri_1, renamedNode_1;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!tree) {
                            return [2 /*return*/];
                        }
                        fromNode = (0, utils_1.getNodeByUri)(tree, fromUri);
                        toNode = (0, utils_1.getNodeByUri)(tree, toUri);
                        if ((toNode === null || toNode === void 0 ? void 0 : toNode.type) === "file") {
                            toNode = (0, utils_1.getParentNode)(tree, toNode.uri);
                        }
                        if (!(fromNode && toNode)) return [3 /*break*/, 2];
                        return [4 /*yield*/, ((_a = props.onMove) === null || _a === void 0 ? void 0 : _a.call(props, fromNode, toNode))];
                    case 1:
                        _c.sent();
                        finalTree_1 = (0, utils_1.removeNode)(tree, fromUri);
                        name_1 = fromUri.split("/").pop();
                        renamedUri_1 = toUri + "/" + name_1;
                        if ((_b = toNode.children) === null || _b === void 0 ? void 0 : _b.find(function (node) { return node.uri === renamedUri_1; })) {
                            // todo: 错误提示
                            return [2 /*return*/];
                        }
                        renamedNode_1 = (0, utils_1.treeMap)(fromNode, function (item) {
                            var newUri = item.uri.replace(fromUri, renamedUri_1);
                            return __assign(__assign({}, item), { renaming: false, uri: newUri });
                        });
                        handleTreeChange(function (t) { return t && (0, utils_1.addChildTo)(finalTree_1, toUri, renamedNode_1); });
                        _c.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        }); },
    };
    if (props.handlerRef) {
        props.handlerRef.current = handlers;
    }
    var timeoutRef = (0, react_1.useRef)(0);
    var rowRenderer = function (params) {
        var _a;
        var treeNode = items[params.index];
        var indent = props.indent || 10;
        var treeItemRenderer = props.treeItemRenderer ||
            (function (treeNode) { return react_1.default.createElement("div", null, (0, utils_1.getFileName)(treeNode.uri)); });
        return (react_1.default.createElement(TreeItem_1.TreeItem, { indentUnit: props.indentUnit || "px", indent: indent * (0, utils_1.calcLevel)(treeNode.uri, ((_a = props.root) === null || _a === void 0 ? void 0 : _a.uri) || ""), style: params.style, treeNode: treeNode, onContextMenu: props.onContextMenu, treeItemRenderer: treeItemRenderer, onClick: handleItemExpand, onDragOver: function (e, node) {
                clearTimeout(timeoutRef.current);
                // 延时一点展开目录或者收缩目录，防止误操作
                timeoutRef.current = window.setTimeout(function () {
                    handleItemExpand(node);
                }, 500);
            }, onDrop: function (e, from, to) {
                clearTimeout(timeoutRef.current);
                handlers.move(from, to);
            } }));
    };
    return (react_1.default.createElement(react_virtualized_1.AutoSizer, null, function (_a) {
        var height = _a.height, width = _a.width;
        return (react_1.default.createElement(react_virtualized_1.List, { className: "file-tree", height: height, width: width, overscanRowCount: 30, noRowsRenderer: (props === null || props === void 0 ? void 0 : props.emptyRenderer) || defaultEmptyRenderer, rowCount: items.length, rowHeight: 30, rowRenderer: rowRenderer }));
    }));
};
exports.FileTree = FileTree;
