"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TreeItem = void 0;
var react_1 = __importDefault(require("react"));
var TreeItem = function (_a) {
    var treeNode = _a.treeNode, onContextMenu = _a.onContextMenu, treeItemRenderer = _a.treeItemRenderer, indent = _a.indent, indentUnit = _a.indentUnit, style = _a.style, onClick = _a.onClick, onDragOver = _a.onDragOver, onDrop = _a.onDrop;
    return (react_1.default.createElement("div", { className: "file-tree__tree-item", title: treeNode.uri, draggable: true, onDrop: function (e) {
            e.preventDefault();
            e.currentTarget.style.backgroundColor = "#fff";
            var from = e.dataTransfer.getData("text/plain");
            var to = treeNode.uri;
            onDrop === null || onDrop === void 0 ? void 0 : onDrop(e, from, to);
        }, onDragOver: function (e) {
            e.currentTarget.style.backgroundColor = "#eee";
            e.preventDefault();
            onDragOver === null || onDragOver === void 0 ? void 0 : onDragOver(e, treeNode);
        }, onDragEnter: function (e) {
            e.currentTarget.style.backgroundColor = "#eee";
        }, onDragLeave: function (e) {
            e.currentTarget.style.backgroundColor = "#fff";
        }, 
        // onDragOver={e => console.log(e)}
        onDragStart: function (e) {
            // e.dataTransfer.dropEffect = "move";
            e.dataTransfer.setData("text/plain", treeNode.uri);
        }, onClick: function () { return onClick(treeNode); }, style: __assign(__assign({ whiteSpace: 'nowrap' }, style), { boxSizing: 'border-box', paddingLeft: indent + indentUnit }), onContextMenu: function (e) { return onContextMenu === null || onContextMenu === void 0 ? void 0 : onContextMenu(e, treeNode); } }, treeItemRenderer(treeNode)));
};
exports.TreeItem = TreeItem;
